// ---------------------------------------------------------------------------
/*
 * (c) Copyright 2010, Allan Petersen
 * ALL RIGHTS RESERVED
 * Permission to use, copy, modify, and distribute this software for
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that
 * the name of Allan Petersen not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission.
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL ALLAN
 * PETERSEN BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT ALLAN PETERSEN HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * www.allanpetersen.com
 *
 */
// ---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
// ---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TOpenGLAPPanel"
#pragma resource "*.dfm"
TForm1 *Form1;

// ---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner) {
}

// ---------------------------------------------------------------------------
void __fastcall TForm1::OpenGLAPPanel1Init(TObject *Sender) {
	glShadeModel(GL_SMOOTH); // Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f); // Black Background
	glClearDepth(1.0f); // Depth Buffer Setup
	glEnable(GL_DEPTH_TEST); // Enables Depth Testing
	glDepthFunc(GL_LEQUAL); // The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	// Really Nice Perspective Calculations
}

// ---------------------------------------------------------------------------
void __fastcall TForm1::OpenGLAPPanel1Paint(TObject *Sender) {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	// Clear Screen And Depth Buffer
	glLoadIdentity(); // Reset The Current Modelview Matrix
	glTranslatef(-1.5f, 0.0f, -6.0f); // Move Left 1.5 Units And Into The Screen 6.0
	glBegin(GL_TRIANGLES); // Drawing Using Triangles
	glVertex3f(0.0f, 1.0f, 0.0f); // Top
	glVertex3f(-1.0f, -1.0f, 0.0f); // Bottom Left
	glVertex3f(1.0f, -1.0f, 0.0f); // Bottom Right
	glEnd(); // Finished Drawing The Triangle
	glTranslatef(3.0f, 0.0f, 0.0f); // Move Right 3 Units
	glBegin(GL_QUADS); // Draw A Quad
	glVertex3f(-1.0f, 1.0f, 0.0f); // Top Left
	glVertex3f(1.0f, 1.0f, 0.0f); // Top Right
	glVertex3f(1.0f, -1.0f, 0.0f); // Bottom Right
	glVertex3f(-1.0f, -1.0f, 0.0f); // Bottom Left
	glEnd(); // Done Drawing The Quad
}

// ---------------------------------------------------------------------------
void __fastcall TForm1::OpenGLAPPanel1Resize(TObject *Sender) {
	if (OpenGLAPPanel1->Height == 0) // Prevent A Divide By Zero By
	{
		OpenGLAPPanel1->Height = 1; // Making Height Equal One
	}

	glViewport(0, 0, OpenGLAPPanel1->Width, OpenGLAPPanel1->Height);
	// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION); // Select The Projection Matrix
	glLoadIdentity(); // Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f, (GLfloat)OpenGLAPPanel1->Width / (GLfloat) OpenGLAPPanel1->Height, 0.1f, 100.0f);

	glMatrixMode(GL_MODELVIEW); // Select The Modelview Matrix
	glLoadIdentity(); // Reset The Modelview Matrix
}
// ---------------------------------------------------------------------------
